ProtoPlayer = {}


ProtoPlayer.new = function(x, y)
    local self = {}
    self.name = 'noname'
    self.x = x
    self.y = y
    self.width = 50
    self.height = 50
    self.x2 = self.x + self.width
    self.y2 = self.y + self.height
    self.speed = 200
    self.y_velocity = 0
    self.jump_height = -400
    self.gravity = -500
    self.color = {255, 0, 0}
    self.direction = 1
    self.hightesplat = love.graphics.getHeight() + 150
    self.hightesplat_height = 0

    self.draw = function ()
        love.graphics.setColor(unpack(self.color))
        love.graphics.rectangle('fill', self.x, self.y, self.width, self.height)
        love.graphics.setColor({0,0,0})
        love.graphics.print( 'x: ' .. round(self.x,0), self.x, self.y)
        love.graphics.print( 'x2 ' .. round(self.x2,0), self.x, self.y +10)
    end

    self.setcolor = function (color)
        if color == 'blue' then
            self.color = {0, 0, 255}
        elseif color == 'red' then
            self.color = {255, 0, 0}
        else self.color = {0, 255, 0} end
    end


    self.move = function (self, dt)
        if love.keyboard.isDown('d') then
            if self.x < (love.graphics.getWidth() - 50) then
                self.x = self.x + (self.speed * dt)
            end
        elseif love.keyboard.isDown('a') then
            if self.x > 0 then
                self.x = self.x - (self.speed * dt)
            end
        end

        if love.keyboard.isDown('space') then
            if self.y_velocity == 0 then
                self.y_velocity = self.jump_height
            end
        end
    end


    self.physic = function (self, dt, plattforms)

        if self.y2 > love.graphics.getHeight() then gameover = true end -- if player falls below the screen = gameover

        self.x2 = self.x + self.width -- update self.x2
        self.y2 = self.y + self.height -- update self.y2

        self.y = self.y + self.y_velocity * dt
        self.y_velocity = self.y_velocity - self.gravity * dt
        self.highestplat = love.graphics.getHeight() + 150
        for _k, plat in pairs(plattforms) do
            if self.x2 > plat.x and self.x < plat.x2 then
                if self.y + self.height <= plat.y + plat.height then
                    if plat.y < self.highestplat then self.highestplat, self.highestplat_height = plat.y, plat.height end
                end
            end
        end
        if self.y + self.height >= self.highestplat then
            self.y_velocity = 0
            self.y = self.highestplat - self.height
        end
    end

    local emptyplatform = ProtoPlattform.new(0,0,0,0, 'no ground') -- create empty platform object for return with self.contact if there is no valid real platform
    self.contact = function (self, dt, plattforms)
        local platobject
        for k, v in pairs(plattforms) do
            if self.x2 > v.x and self.x < v.x2 and self.y <= v.ground then
                platobject = v
            end
        end
        if platobject == nil then platobject = emptyplatform  end
        return platobject
    end


    self.switchdirection = function(self)
        if self.direction == 1 then self.direction = -1
        else self.direction = 1 end
    end

    self.ai = function (self, dt, player, plattforms)
        local platobject = self:contact(dt, plattforms)

        if self.x < platobject.x or self.x2 > platobject.x2 then
            self:switchdirection()
        end
        -- walking
        self.x = self.x + self.direction * (self.speed * dt)

    end

    return self
end
